/*
 * LecType1.java
 *
 * Created on March 9, 2003, 5:31 PM
 */

/**
 *
 * @author  Ravi
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import graphs.*;


public class LecType1 extends javax.swing.JApplet {
    private GraphPanel currentGraph;
    
    /** Creates new form LecType1 */
    public LecType1() {
        initComponents();
        this.getContentPane().setBackground(this.getBackground());
    }
    
    public void init(){
        int eqNum = -1;
        try {
            eqNum = Integer.parseInt(getParameter("eqNum"));
        } catch(Exception e){
            e.printStackTrace();
        }
        
        String functionName = "";
        String xAxisImgName = "";
        String yAxisImgName = "";
        String[] sliderImageNames = null;
        
        switch(eqNum){
            case 0:
                currentGraph = new TDSourcePGraph();
                functionName = "images/Eqn101.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/mparam.JPG";
                break;
            case 1:
                currentGraph = new CosGraph();
                functionName = "images/vote.gif";
                break;
           /* case 2:
                currentGraph = new CosGraph2();
                functionName = "images/vote.gif";
                break;*/
            case 3:
                currentGraph = new TDSourceVGraph();
                functionName = "images/Eqn102.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/vr.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/mparam.JPG";
                
                break;
            case 4:
                currentGraph = new TDSourceCGraph();
                functionName = "images/Eqn103.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/chi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/mparam.JPG";
                break;
                
            case 5:
                currentGraph = new TDVortexPGraph();
                functionName = "images/Eqn104.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/gamma.JPG";
                
                break;
            case 6:
                currentGraph = new TDVortexVGraph();
                functionName = "images/Eqn105.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/vtheta.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/gamma.JPG";
                break;
            case 7:
                currentGraph = new TDVortexCGraph();
                functionName = "images/Eqn106.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/chi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/gamma.JPG";
                break;
            case 8:
                currentGraph = new StagPtXGraph();
                functionName = "images/Eqn107.JPG";
                yAxisImgName = "images/xs.JPG";
                xAxisImgName = "images/m.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/uparam.JPG";
                break;
                
            case 9:
                currentGraph = new RHBodyWGraph();
                functionName = "images/Eqn108.JPG";
                yAxisImgName = "images/D.JPG";
                xAxisImgName = "images/m.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/uparam.JPG";
                break;
                
            case 10:
                currentGraph = new ROvoidGraph();
                functionName = "images/Eqn109.JPG";
                xAxisImgName = "images/a.JPG";
                yAxisImgName = "images/xs.JPG";
                sliderImageNames = new String[2];
                sliderImageNames[0] = "images/uparam.JPG";
                sliderImageNames[1] = "images/mparam.JPG";
                break;
                
            case 11:
                currentGraph = new DispersionGraph();
                functionName = "images/Eqn191.JPG";
                xAxisImgName = "images/k.JPG";
                yAxisImgName = "images/omega.JPG";
                sliderImageNames = new String[2];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                break;
                
            case 12:
                currentGraph = new PhaseVelocityGraph();
                functionName = "images/Eqn193.JPG";
                xAxisImgName = "images/k.JPG";
                yAxisImgName = "images/vp.JPG";
                sliderImageNames = new String[2];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                break;
                
            case 13:
                currentGraph = new GroupVelocityGraph();
                functionName = "images/Eqn194.JPG";
                xAxisImgName = "images/k.JPG";
                yAxisImgName = "images/cg.JPG";
                sliderImageNames = new String[2];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                
                break;
                
            case 14:
                currentGraph = new WaveResistanceGraph();
                functionName = "images/vote.gif";
                break;
                
            case 15:
                currentGraph = new DispersionRelationGraph();
                functionName = "images/Eqn195.JPG";
                xAxisImgName = "images/omega.JPG";
                yAxisImgName = "images/k.JPG";
                sliderImageNames = new String[2];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                
                
                
                break;
                
            case 16:
                currentGraph = new ParticleOrbitGraph();
                functionName = "images/vote.gif";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/aparam.JPG";
                sliderImageNames[1] = "images/h.JPG";
                sliderImageNames[2] = "images/kparam.JPG";
                
                break;
                
            case 17:
                currentGraph = new IntersectTanhGraph();
                
                functionName = "images/Eqn192.JPG";
                xAxisImgName = "images/c1c2.JPG";
                yAxisImgName = "images/kh.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/g.JPG";
                sliderImageNames[2] = "images/omegaparam.JPG";
                break;
                
                
            case 18:
                currentGraph = new MunkMomentGraph();
                functionName = "images/Eqn121.JPG";
                xAxisImgName = "images/theta.JPG";
                yAxisImgName = "images/m3.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/m11.JPG";
                sliderImageNames[1] = "images/m22.JPG";
                sliderImageNames[2] = "images/uparam.JPG";
                break;
                
            case 19:
                currentGraph = new UCRGraph();
                
                functionName = "images/Eqn122.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[6];
                sliderImageNames[0] = "images/h.JPG";
                sliderImageNames[1] = "images/ia.JPG";
                sliderImageNames[2] = "images/rho.JPG";
                sliderImageNames[3] = "images/g.JPG";
                sliderImageNames[4] = "images/m11.JPG";
                sliderImageNames[5] = "images/m22.JPG";
                
                break;
            case 20:
                currentGraph = new ImageMethodGraph();
                functionName = "images/Eqn111.JPG";
                xAxisImgName = "images/ba.JPG";
                yAxisImgName = "images/vru.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/thetaparam.JPG";
                break;
                
            case 21:
                currentGraph = new ImageMethod2Graph();
                functionName = "images/Eqn111.JPG";
                xAxisImgName = "images/ba.JPG";
                yAxisImgName = "images/vru.JPG";
                sliderImageNames = new String[3];
                sliderImageNames[0] = "images/thetaparam.JPG";
                sliderImageNames[1] = "images/ha.JPG";
                sliderImageNames[2] = "images/n.JPG";
                break;
                
                
                
                
                
            default:
                currentGraph = new TDSourcePGraph();
                functionName = "images/Eqn101.JPG";
                xAxisImgName = "images/r.JPG";
                yAxisImgName = "images/phi.JPG";
                sliderImageNames = new String[1];
                sliderImageNames[0] = "images/r.JPG";
                
                
                
                break;
        }
        
        
        
        Image xAxisImg = null;
        Image yAxisImg = null;
        Image img = null;
        Image[] sliderImages = new Image[sliderImageNames.length];
        try {
            img = this.getImage(getCodeBase(), functionName);
            labelFunction.setIcon(new ImageIcon(img));
            
            xAxisImg = this.getImage(getCodeBase(), xAxisImgName);
            yAxisImg = this.getImage(getCodeBase(), yAxisImgName);
            
            for(int i=0; i<sliderImageNames.length; i++){
                sliderImages[i] = this.getImage(getCodeBase(), sliderImageNames[i]);
            }
            
            //labelFunction.setText("foo");
        } catch(Exception e){
            e.printStackTrace();
        }
        
        // adds the graph to the graphpanel
        GraphAreaPanel.add(currentGraph, BorderLayout.CENTER);
        currentGraph.setXAxisImg(xAxisImg);
        currentGraph.setYAxisImg(yAxisImg);
        currentGraph.setSliderImages(sliderImages);
        
        // add options jsliders
        this.getContentPane().add(currentGraph.getOptionsPanel(), BorderLayout.SOUTH);
    }
    
    public void start(){
    }
    public void stop(){
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        FunctionPanel = new javax.swing.JPanel();
        labelFunction = new javax.swing.JLabel();
        GraphAreaPanel = new javax.swing.JPanel();

        setBackground(new java.awt.Color(204, 204, 204));
        FunctionPanel.add(labelFunction);

        getContentPane().add(FunctionPanel, java.awt.BorderLayout.NORTH);

        GraphAreaPanel.setLayout(new java.awt.BorderLayout());

        getContentPane().add(GraphAreaPanel, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel labelFunction;
    private javax.swing.JPanel FunctionPanel;
    private javax.swing.JPanel GraphAreaPanel;
    // End of variables declaration//GEN-END:variables
    
    private ChangeListener listener;
    
}
