

/*
 * GraphPanel.java
 *
 * Created on March 9, 2003, 5:30 PM
 */

/**
 *
 * @author  Ravi
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;


public class GraphPanel extends javax.swing.JPanel implements Runnable {
    private double w1, w2, A, tmin, tmax, tstep;
    private double xOffset, xScale, yOffset, yScale, i, j;
    private boolean timetodraw;
    
    
    private double k1, k2, xmin, xmax, ymin, ymax, x, y, t, dx, di, espeed, pspeed, node, crest;
    
    public double g = 9.8;
     
    
    private double frame, frameholder;
    private int delay;
    private Thread animator;
    Polygon grapher;
    
    /** Creates new form GraphPanel */
    public GraphPanel() {
             initComponents();
             delay = 100;
             frame = 0;
             frameholder = 0;
           System.out.println("w1"+w1);
           timetodraw = false;
  
                
    }
    
    public void GetDelay(int appdelay){
        delay = appdelay;
    }
        
        
    public void GetParam(double w1i, double w2i, double Ai, double tmini, double tmaxi, double tstepi)
    {
        w1 = w1i;
        w2 = w2i;
        A = Ai;
        tmin = tmini;
        tmax = tmaxi;
        tstep = tstepi;
        frameholder = tmini;
        frame = frameholder;
        Drawer();
    }
    
    public void PauseMe(){
        frameholder = frame;
        
            System.out.println("frame"+frame+"frameholder"+frameholder);
        animator.stop();
        frame = 0;
    }
    
    public void StartMe(){
        frame = frameholder;
                  System.out.println("frame"+frame+"frameholder"+frameholder);
  
        animator = new Thread(this);
        animator.start();
    }
    public void ClearMe(){
        getGraphics().clearRect(0,0,getWidth(), getHeight());
        frame = 0;
        frameholder = 0;
        animator.stop();
    }
       
    
    /*
     
       public void start() {
        animator = new Thread(this);
        frame = 0;
     
     
     
    }
     */
    
    /**
     * This method is called by the thread that was created in
     * the start method. It does the main animation.
     */
    public void run() {
	while (Thread.currentThread() == animator && frame<tmax) {
	    // Display the next frame of animation.
	    repaint();
	    
	    // Delay for a while
	    try {
		Thread.sleep(delay);
	    } catch (InterruptedException e) {
		break;
	    }

	    // Advance the frame
	    frame+=tstep;
	}
	frame = tmin;
	

    }

    
    /**
     * This method is called when the applet is no longer
     * visible. Set the animator variable to null so that the
     * thread will exit before displaying the next frame.
     */
    public void stop() {
        animator = null;
    }
    

    
    
    
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        
        setLayout(new java.awt.BorderLayout());
        
        setBackground(new java.awt.Color(0, 255, 255));
        setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 51, 204)));
    }
    
    
    public void paintComponent(Graphics gr){
        
        if (timetodraw){
            int width = getWidth();
            int height = getHeight();
            
            gr.setColor(Color.cyan);
            gr.fillRect(0,0,width, height);
            gr.setColor(Color.black);
            
            // offsets/scales
            xOffset = width / 2;
            xScale = -xOffset / xmin;
            yOffset = height/2.0;
            yScale = -yOffset / ymax;
            
          
            
            // axis
            
            gr.drawLine(width/2, 0, width/2, height);
            
            gr.drawLine(0, height/ 2, width , height/ 2);
            
            
            //System.out.println("");
            Polygon grapher = new Polygon();
            
            
            for (i = 0; i <width; i+=di) {
                x = (i-xOffset)/xScale;
                y=A*Math.cos(k2*x-w2*frame)+A*Math.cos(k1*x-w1*frame);
                j = yScale * y + yOffset;
                grapher.addPoint((int) i, (int) j);
                
                
            }
            gr.drawPolyline(grapher.xpoints, grapher.ypoints, grapher.npoints);
            grapher = new Polygon();
            gr.setColor(Color.blue);
            
            x = node + espeed * frame;
            y = Math.abs(2.0 * A*Math.cos( .5*Math.abs(k1-k2)*x - .5*Math.abs(w1-w2)*frame)  ) + A / 2.5  ;
            j = yScale * y + yOffset;
            i = xScale * x + xOffset;
            
            
            gr.fillOval((int) i % width, (int) (j-4.0), 8, 8);
            
            gr.setColor(Color.red);
            
            x = crest + pspeed * frame;
            y = Math.abs(2.0 * A*Math.cos( .5*Math.abs(k1-k2)*x - .5*Math.abs(w1-w2)*frame)  )  + A / 2.5;
            j = yScale * y + yOffset;
            i = xScale * x + xOffset;
            
            
            gr.fillRect( (int) i % width, (int) (j-4.0), 8, 8);
            
            
            
        }
        
        
        
        
        
        
    }
    
    
    
    
    
     public void Drawer() {
        
        k1 = w1*w1/g;
        k2 = w2*w2/g;
        
        espeed = Math.abs(w1-w2) / Math.abs(k1-k2);
        pspeed = ((w1 + w2) / 2.0 )/ ( (k1 + k2) / 2);
             System.out.println("espeed"+espeed+"pspeed"+pspeed);
          System.out.println("w1"+w1+"w2"+w2);
      
        
        xmax = 2 * Math.PI / Math.abs(k1 - k2);
        xmin = -1.0*xmax;
        ymax = Math.ceil(3.0*A / 10.0) * 10.0;
        ymin = -ymax;
        
          
        frame = frameholder;
        dx = Math.min(2*Math.PI * g / (10.0 * w1*w1), 2*Math.PI*g / (10.0 * w2*w2));
        
        node = xmin / 2.0;
        crest = xmin;
        
        
        di = Math.max(.25, dx*xScale);
        grapher = new Polygon();
        timetodraw = true;
        animator = new Thread(this);
        
        animator.start();
    }
    
    
    
    
    
}
