package graphs;

/*
 * SinGraph.java
 *
 * Created on March 10, 2003, 9:52 PM
 */

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;

public class CosGraph extends SingleSliderGraph{
    
    /** Creates a new instance of SinGraph */
    public CosGraph() {
    } 
    
    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double x = (i-xOffset)/xScale;
            double y = Math.cos( p1/50.0 *  x);
            double j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }        
        
        return grapher;        
    }
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
}
 