package graphs;

/*
 * SinGraph.java
 *
 * Created on March 10, 2003, 9:52 PM
 */

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

public abstract class DoubleSliderGraph extends GraphPanel{
    
    
    public JSuperSlider jSlider1;
    public JSuperSlider jSlider2;
    
    /** Creates a new instance of SinGraph */
    public DoubleSliderGraph() {
        jSlider1 = new JSuperSlider();
//        jSlider1 = new JSuperSlider(0,20);
        //jSlider1.setMinimum(0);
        //jSlider1.setMaximum(20);
//        jSlider2 = new JSuperSlider(0,20,0);
        jSlider2 = new JSuperSlider();
        
        ChangeListener listener = new ChangeListener(){
            public void stateChanged(ChangeEvent event){
                SetParam2((double)jSlider1.getValue()/1000, (double)jSlider2.getValue()/1000);
            }
        };

        jSlider1.setPaintTicks(true);
        jSlider1.setMajorTickSpacing(2000);
        jSlider1.setMinorTickSpacing(1000);
        jSlider1.setMinimum(-10000);
        jSlider1.setMaximum(10000);
        Hashtable labelTable1 = new Hashtable();
        for (int i=-10; i<=10;i+=2)
        labelTable1.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider1.setLabelTable(labelTable1);
        jSlider1.setPaintLabels(true);
        jSlider1.addChangeListener(listener);        
        
        
        jSlider2.setPaintTicks(true);
        jSlider2.setMajorTickSpacing(2000);
        jSlider2.setMinorTickSpacing(1000);
        jSlider2.setMinimum(-10000);
        jSlider2.setMaximum(10000);
        Hashtable labelTable2 = new Hashtable();
        for (int i=-10; i<=10;i+=2)
        labelTable2.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider2.setLabelTable(labelTable2);
        jSlider2.setPaintLabels(true);
        jSlider2.addChangeListener(listener);        
        
    }
    
    public JPanel getOptionsPanel() {
        jPanel = new JPanel();
        
        innerPanel = new JPanel(new GridLayout(2,1));
        
        jSlider1.setImage(this.getSliderImage(0));
        jSlider2.setImage(this.getSliderImage(1));
        
        innerPanel.add(jSlider1.getContainer());
        innerPanel.add(jSlider2.getContainer());
        
        jPanel.add(innerPanel);
        return jPanel;
    }
public JPanel jPanel,innerPanel;
   
    
}



