/*
 * GroupVelocityGraph.java
 *
 * Created on March 11, 2003, 1:33 AM
 */

package graphs;

/**
 *
 * @author  Ravi
 */



import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

public class GroupVelocityGraph_nondimensional extends SingleSliderGraph{
    
    /** Creates a new instance of TDSourceVGraph */
    public GroupVelocityGraph_nondimensional() {
        jSlider.setMinimum(0);
        jSlider.setMaximum(20000);        
        jSlider.setValue(10000);        
        jSlider.setMajorTickSpacing(5000);
        jSlider.setMinorTickSpacing(1000);
        Hashtable labelTable = new Hashtable();
        for (int i=0; i<=20;i+=5)
        labelTable.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider.setLabelTable(labelTable);

    }
    
    
    
    
    
    
    
    
            public void restoreDefaults(){
        xmin=0.0001;
        xmax=50;
        ymin=-5;
        ymax=5;
        super.restoreDefaults();
    }
    
    public Polygon computePolygon(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            double x = xMin+i*(xMax-xMin)/width;
//            double y = 1/(2*Math.pow(p2*x*(Math.pow(2.718281828459045, 2.0*x * p1) -1.0)/( Math.pow(2.718281828459045,2.0*x*p1) + 1.0),.5)) * ( Math.pow(2.718281828459045, 2.0*x * p1) -1.0) /  ( Math.pow(2.718281828459045, 2.0*x * p1) + 1.0)  + x * p1 * 1 / (  Math.pow(2.718281828459045, x * p1)  +    Math.pow(2.718281828459045, -x * p1));
            double y = 1/(2*Math.sqrt(x*com.croftsoft.core.math.MathLib.tanh(x)))*p1*(com.croftsoft.core.math.MathLib.tanh(x)+x*Math.pow(sech(x),2));
            xy[(int)(4*i)][1] = y;
//            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
        }        

        
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }
        
    

    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xMin, xMax, yOffset);
        return polyArray;
    }

    
    
    
    
    
    
    
    
    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[1];
        polyArray[0] = computePolygon(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    public Polygon computePolygon(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double x = (i-xOffset)/xScale;
            double y = 1/(2*Math.pow(p2*x*(Math.pow(2.718281828459045, 2.0*x * p1) -1.0)/( Math.pow(2.718281828459045,2.0*x*p1) + 1.0),.5)) * p2 * ( Math.pow(2.718281828459045, 2.0*x * p1) -1.0) /  ( Math.pow(2.718281828459045, 2.0*x * p1) + 1.0)  + p2 * x * p1 * 1 / (  Math.pow(2.718281828459045, x * p1)  +    Math.pow(2.718281828459045, -x * p1));
            double j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
    
}
