/*
 * ParticleOrbitGraph.java
 *
 * Created on March 12, 2003, 6:15 PM
 */

package graphs;

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

public class ParticleOrbitGraph extends TripleSliderGraph{
    
    /** Creates a new instance of TDSourceVGraph */

    
    public ParticleOrbitGraph() {
        jSlider1.setMinimum(0);
        jSlider2.setMinimum(0);
        jSlider1.setMaximum(10000);
        jSlider2.setMaximum(10000);
        jSlider1.setMajorTickSpacing(1000);        
        jSlider2.setMajorTickSpacing(1000);    
              jSlider3.setMinimum(0);
       jSlider3.setMaximum(10000);
            jSlider3.setMajorTickSpacing(1000);
       jSlider1.setValue(3000);
       jSlider2.setValue(6000);
       jSlider3.setValue(50);
    
   
        
    }
    
    
    public Polygon[] computePolygonArray(double xMin, double xMax, double yOffset) {
        Polygon[] polyArray = new Polygon[2];
        polyArray[0] = computePolygon1(xMin, xMax, yOffset);
        polyArray[1] = computePolygon2(xMin, xMax, yOffset);
        return polyArray;
    }
    
    
    public void restoreDefaults(){
        xmin=0.0001;
        xmax=50;
        ymin=-50;
        ymax=50;
        super.restoreDefaults();
        if (!firsttime) {jSlider1.setValue(0);jSlider2.setValue(0);jSlider3.setValue(0);}
    }
    
    public Polygon computePolygon1(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = p1 * sinh(p3 * (xy[(int)(4*i)][0] + p2)) / sinh(p3 * p2); //current value of function, in numbers
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }        

    public Polygon computePolygon2(double xMin, double xMax, double yOffset) {
        Polygon grapher = new Polygon();
        
        double[][] xy=new double[4*this.getWidth()][2];
        //        double min=0d, max=0d;
        System.out.println("p1:"+p1);
        xScale=this.getWidth()/(xmax-xmin); System.out.println("xScale:"+xScale);
        yScale=this.getHeight()/(ymax-ymin); System.out.println("yScale:"+yScale);
        for (double i = 0; i < this.getWidth(); i += DI){
            // build array of x and y, then find min and max
            xy[(int)(4*i)][0] = xMin+i*(xMax-xMin)/width; //current value on x-axis, in numbers, not pixels
            xy[(int)(4*i)][1] = p1 * cosh(p3 * (xy[(int)(4*i)][0] + p2)) / sinh(p3 * p2); //current value of function, in numbers
        }
        
        for (double i = 0; i < this.getWidth(); i += DI){
            double j = -yScale * xy[(int)(4*i)][1] + yOffset; //current value of function, in pixels
//            System.out.println("am here");
            System.out.println("("+xy[(int)(4*i)][0]+","+xy[(int)(4*i)][1]+")");
            grapher.addPoint((int) i, (int) j);
        }
        return grapher;
    }        
    
    
    
    
    
    
    
    
    
    
    
    
    
    public Polygon[] computePolygonArray(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon[] polyArray = new Polygon[2];
        polyArray[0] = computePolygon1(xScale, xOffset, yScale, yOffset);
        polyArray[1] = computePolygon2(xScale, xOffset, yScale, yOffset);
        return polyArray;
    }
    public Polygon computePolygon2(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        double x;
        double y;
        double j;
        
        
        for (double i = this.getWidth(); i > 0; i += -DI){
            x = (i-xOffset)/xScale;
            y = p1 * cosh(p3 * (x + p2)) / sinh(p3 * p2);
            j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        return grapher;
    }
    public Polygon computePolygon1(double xScale, double xOffset, double yScale, double yOffset) {
        Polygon grapher = new Polygon();
        double x;
        double y;
        double j;
        
      
        for (double i = this.getWidth(); i > 0; i += -DI){
            x = (i-xOffset)/xScale;
            y = p1 * sinh(p3 * (x + p2)) / sinh(p3 * p2);
            j = yScale * y + yOffset;
            //System.out.print("("+x+","+y+")");
            grapher.addPoint((int) i, (int) j);
        }
        
        
        
        return grapher;
    }    
    
           public static double sinh(double myAngle) {
          double sinh = (Math.exp(myAngle)-Math.exp(-myAngle))/2;
          return sinh;
     }
     public static double cosh(double myAngle) {
          double cosh = (Math.exp(myAngle)+Math.exp(-myAngle))/2;
          return cosh;}
    
}