/*
 * TripleSliderGraph.java
 *
 * Created on March 12, 2003, 6:13 PM
 */

package graphs;

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;


public abstract class TripleSliderGraph extends GraphPanel{
    
    
    protected JSuperSlider jSlider1 = new JSuperSlider(-10000, 10000);
    protected JSuperSlider jSlider2 = new JSuperSlider(-10000,10000);
    protected JSuperSlider jSlider3 = new JSuperSlider(-10000,10000);
    
       
       /** Creates a new instance of SinGraph */
    public TripleSliderGraph() {
        ChangeListener listener = new ChangeListener(){
            public void stateChanged(ChangeEvent event){
                SetParam3((double)jSlider1.getValue()/1000, (double)jSlider2.getValue()/1000,(double)jSlider3.getValue()/1000);
                
                
            }
        };
        
        jSlider1.setPaintTicks(true);
        jSlider1.setPaintLabels(true);
        jSlider1.setMinimum(-10000);
        jSlider1.setMaximum(10000);
        jSlider1.setMajorTickSpacing(2000);
        jSlider1.setMinorTickSpacing(1000);
        Hashtable labelTable1 = new Hashtable();
        for (int i=-10; i<=10;i+=2)
        labelTable1.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider1.setLabelTable(labelTable1);
        jSlider1.setPaintLabels(true);
        jSlider1.addChangeListener(listener);
        
        jSlider2.setPaintTicks(true);
        jSlider2.setPaintLabels(true);
        jSlider2.setMinimum(-10000);
        jSlider2.setMaximum(10000);
        jSlider2.setMajorTickSpacing(2000);
        jSlider2.setMinorTickSpacing(1000);
        Hashtable labelTable2 = new Hashtable();
        for (int i=-10; i<=10;i+=2)
        labelTable2.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider2.setLabelTable(labelTable2);
        jSlider2.setPaintLabels(true);
        jSlider2.addChangeListener(listener);        
        
        jSlider3.setPaintTicks(true);
        jSlider3.setPaintLabels(true);
        jSlider3.setMinimum(-10000);
        jSlider3.setMaximum(10000);
        jSlider3.setMajorTickSpacing(2000);
        jSlider3.setMinorTickSpacing(1000);
        Hashtable labelTable3 = new Hashtable();
        for (int i=-10; i<=10;i+=2)
        labelTable3.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider3.setLabelTable(labelTable3);
        jSlider3.setPaintLabels(true);
        jSlider3.addChangeListener(listener);        
    }
    
    public JPanel getOptionsPanel() {
        JPanel jPanel = new JPanel();
        
        JPanel innerPanel = new JPanel(new GridLayout(3,1));
        
        jSlider1.setImage(this.getSliderImage(0));
        jSlider2.setImage(this.getSliderImage(1));
        jSlider3.setImage(this.getSliderImage(2));
        
        innerPanel.add(jSlider1.getContainer());
        innerPanel.add(jSlider2.getContainer());
        innerPanel.add(jSlider3.getContainer());
        
        jPanel.add(innerPanel);
        return jPanel;
    }

 
    
}




