package graphs;

/*
 * JSuperSlider.java
 *
 * Created on March 11, 2003, 11:16 PM
 */

/**
 *
 * @author  Ravi
 */
import javax.swing.*;
import java.awt.*;

public class JSuperSlider extends JSlider {
    private JPanel containerPanel = new JPanel(new BorderLayout());
    
    public JSuperSlider(){
        super();
        super.setSnapToTicks(false);
    }
    public JSuperSlider(int min, int max){
        super(min,max);
    }
    
    public JSuperSlider(int min, int max, int value){
        super(min,max, value);
    }
        
    public void setImage(Image sliderImg){
        if(sliderImg != null){
            jLabel = new JLabel(new ImageIcon(sliderImg));            
        } else {
            jLabel = new JLabel();
        }
        
        containerPanel.add(this, BorderLayout.CENTER);
        containerPanel.add(jLabel, BorderLayout.WEST);        
    }

    public void setImageVisible(boolean b){
        jLabel.setVisible(b);
    } 
    
      
    public JPanel getContainer(){
        return containerPanel;
    }
public JLabel jLabel;
}
