package graphs;

/*
 * SinGraph.java
 *
 * Created on March 10, 2003, 9:52 PM
 */

/**
 *
 * @author  Ravi
 */
import java.awt.*;
import javax.swing.*;
import java.util.*;
import javax.swing.event.*;

public abstract class SingleSliderGraph extends GraphPanel{
    public JSuperSlider jSlider = new JSuperSlider(-10,10);
    
    /** Creates a new instance of SinGraph */
    public SingleSliderGraph() {        
        ChangeListener listener = new ChangeListener(){
            public void stateChanged(ChangeEvent event){
               SetParam((double)jSlider.getValue()/1000);
            }
        };        
        jSlider.setPaintTicks(true);
        jSlider.setMajorTickSpacing(2000);
        jSlider.setMinorTickSpacing(1000);
        jSlider.setMinimum(-10000);
        jSlider.setMaximum(10000);
        Hashtable labelTable = new Hashtable();
        for (int i=-10; i<=10;i+=2)
        labelTable.put( new Integer( i*1000 ), new JLabel(Integer.toString(i)) );
        jSlider.setLabelTable(labelTable);
        jSlider.setPaintLabels(true);
        jSlider.addChangeListener(listener);
    } 
    
    public JPanel getOptionsPanel() {
        JPanel jPanel = new JPanel();
        
         jSlider.setImage(this.getSliderImage(0));
        
        
        
        jPanel.add(jSlider.getContainer());
        return jPanel;        
    }
  
}


        
       
      